<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Panel extends MY_Controller {
	

	public function index()
	{
		show_404();

	}

	public function dashboard()
	{
		$this->DATA['menu'] 	= 'dashboard';	
		$this->DATA['title'] 	= 'Dashboard';	
		
		
			


		$this->DATA['users'] 		= $this->Admin->getCountTable("users");
		$this->DATA['bookmarks'] 	= $this->Admin->getCountTable("bookmarks");
		$this->DATA['codes'] 		= $this->Admin->getCountTable("codes");
		$size = $this->db->query("SELECT SUM(size) as total FROM {PRE}codes")->row();
		$this->DATA['totalSize'] 		= $size->total;
		
		$sql = "SELECT * FROM {PRE}codes,{PRE}codes_users  WHERE {PRE}codes.username = {PRE}codes_users.username  ORDER BY {PRE}codes.rating  DESC LIMIT 10";	 	
	 	$this->DATA['top']['rated']  = $this->db->query($sql)->result();

	 	$sql = "SELECT * FROM {PRE}codes,{PRE}codes_users  WHERE {PRE}codes.username = {PRE}codes_users.username  ORDER BY views  DESC LIMIT 10";	 	
	 	$this->DATA['top']['views']  = $this->db->query($sql)->result();

	 	$sql = "SELECT * FROM {PRE}codes,{PRE}codes_users  WHERE {PRE}codes.username = {PRE}codes_users.username  ORDER BY downloads  DESC LIMIT 10";	 	
	 	$this->DATA['top']['downloads']  = $this->db->query($sql)->result();

		
		
		
		$this->DATA['registered'] 	= $this->Admin->getRegisteredUsersByMonth();
		
		$this->show("dashboard");
	}	


	public function externalservices()
	{

		if(!is_sadmin())
			show_404();
		if($this->input->post())
		{
			$this->save_settings();
			redirect(base_url()."admin/externalservices");
		}

		$this->DATA['menu'] 	= 'externalservices';	
		$this->DATA['title'] 	= 'External Services';	
		if(is_demo())
			$this->show("demo");
		else
			$this->show("externalservices");
	}	

	public function about()
	{

		if(!is_sadmin())
			show_404();
	
		$this->DATA['title'] 	= 'About';	
		$this->DATA['changelog'] 	= file_get_contents("./update/changelog.txt");
		$this->DATA['menu'] 	= 'about';	
		$this->show("about");
	}	


	public function bulk()
	{
		$this->DATA['title'] 	= 'Bulk';	
		if(!is_sadmin())
			show_404();
		if($sites = $this->input->post("bulk"))
		{
			$this->session->set_flashdata('sites', $sites);
			$site = explode("\n",$sites);
			//if(count($site)<=10000)
			//{	
				$added = 0;
				foreach ($site as $key => $url) {				

					$response 	= $this->Admin->setTable("sites",array("url" => $url));
				
					if($response)				
						$added++;
				}
				$messages[] = array("type" => "success","msg" => '<strong>'.number_format($added).'</strong> Domains added successfully');						
				$messages[] = array("type" => "danger","msg" => '<strong>'.number_format(count($site)-$added).'</strong> Domains already exists');						
				

			//}
			//else
			//{
			//	$messages[] = array("type" => "danger","msg" => "Max 10000 sites");
			//}
			
			$this->session->set_flashdata('messages', $messages);
			
			redirect(base_url()."admin/bulk");
		}

		$this->DATA['menu'] 	= 'bulk';	
		$this->show("bulk");
	}	

	public function getUncompleted($next =false)
	{
		if($next)
		{
			$domain 	= $this->Admin->getTable("sites",array("completed" => 0),"registered DESC",'url',1,0)->row();	
			if($domain->num_rows == 0)
				$json['url'] = $domain->url;
			else
				$json['error'] = true;

		}
		else
		{
			$json['n'] = $this->Admin->getCountTable("sites",array("completed" =>0));		
		}
		
		echo_json($json);
	}

	public function translation()
	{	
		$this->DATA['title'] 	= 'Tanslations';	
		if($this->input->post("code"))
		{

			$this->Admin->setTable("languages",array("name" => $this->input->post("name"),"code" => mb_strtolower(trim($this->input->post("code")))));			
			redirect(base_url()."admin/translation/?languages=".mb_strtolower(trim($this->input->post("code"))));
			exit;
		}
		$lang = "en";
		if($this->input->get("language"))
			$lang = $this->input->get("language");

	
		if($this->input->post("r") && $lang != 'en')
		{
			$this->Admin->deleteTable("translation",array("code_lang" =>$lang));
			$this->Admin->deleteTable("languages",array("code" =>$lang));
			redirect(base_url()."admin/translation/");
			exit;
		}
		if($this->input->post() && !$this->input->post("r"))
		{
			foreach ($this->input->post() as $key => $value) {
				$save['code'] 			= $key;
				$save['translation'] 	= $value;
				$save['code_lang'] 		= $lang;
				$data[] = $save;
			}
			$this->Admin->setTable("translation",$data,true);
			foreach ($data as $key => $value) {
				$this->Admin->updateTable("translation",$value,array("code" => $value['code'],"code_lang" => $value['code_lang']));
			}
		}
		
		/*$temp 							= $this->Admin->getTable("translation",array("code_lang" => $lang));		
		if($temp->num_rows() == 0)
		{
			$temp 							= $this->Admin->getTable("translation",array("code_lang" => "en"));		
			foreach ($temp->result_array() as $key => $value) 
			{
				$t[]	 = array("code" => $value['code'],"translation" => '',"helper" => $value['translation']);
			}
			$this->DATA['translation'] 		= $t;
		}
		else
			$this->DATA['translation'] 		= $temp->result_array();*/

		$trans 							= $this->Admin->getTable("translation",array("code_lang" => $lang));		
		
		$temp 							= $this->Admin->getTable("translation",array("code_lang" => "en"));		

		$obj_t = array();
		foreach ($trans->result_array() as $key => $value) 
		{	
			$t[$value['code']] = array(
					"translation" => $value['translation']					
				);
		}
		
		foreach ($temp->result_array() as $key => $value) 
		{
			$t[$value['code']]['helper'] = $value['translation'];
		}
	
	
		$this->DATA['translation'] 		= $t;
		
	
		$complteted = 0;
		foreach ($this->DATA['translation']  as $key => $value) {
			if($value['translation'] != '')
				$complteted++;
		}

		$this->DATA['current'] = $this->Admin->getTable("languages",array("code" => $lang))->row_array();


		$this->DATA['porc'] 			= ceil(($complteted*100)/$temp->num_rows());
		$temp 							= $this->Admin->getTable("languages");	
		$this->DATA['languages'] 		= $temp->result_array();		
		$this->DATA['menu'] 			= 'translation';	
		$this->DATA['lang'] 			= $lang;	
		$this->show("translation");
	}
	
	public function users()
	{	
		if($this->input->get("export"))
		{
			 $this->load->dbutil();
	        $this->load->helper('file');
	        $this->load->helper('download');
	        $delimiter = ",";
	        $newline = "\r\n";
	        $filename = "users.csv";
	        $query = "SELECT names,registered,email,is_admin,avatar FROM {PRE}users limit 10000";
	        $result = $this->db->query($query);
	        $data = $this->dbutil->csv_from_result($result, $delimiter, $newline);
	        force_download($filename, $data);
		}
		$this->DATA['title'] 	= 'Users';	
		if(is_ajax())
		{
			$this->table_users();
			return false;
		}
		
		$this->DATA['menu'] 	= 'users';	

		if(intval($this->input->get("edit"))>0)
		{
			if($this->input->post())
			{
				$user = $this->Admin->getTable("users",array("id" =>  intval($this->input->get("edit"))))->row();	
				$update = $this->input->post();
				if(trim($update['password']) != '')
					$update['password'] = sha1($update['password']);
				else
					unset($update['password']);
				$this->Admin->updateTable("users",$update,array("id" =>  intval($this->input->get("edit"))));
				$this->DATA['alert'] = array("type" => 'success','text' => "User <strong>".$user->names."</strong> updated!");
			}
			$this->DATA['user'] 	= $this->Admin->getTable("users",array("id" =>  intval($this->input->get("edit"))))->row();	

			$this->show("user_edit");
		}
		else
		{
			if(is_demo())
				$this->show("demo");
			else
				$this->show("users");
		}


		
	}	

	public function codes()
	{	
		

		$this->DATA['title'] 	= 'Codes';	
		if(is_ajax())
		{
			$this->table_codes();
			return false;
		}

		if(($this->input->get("remove")))
		{
			$id = trim($this->input->get("remove"));
			$code = $this->Admin->getTable("codes",array("id" => $id))->row();;
			if(count($code)<=0)
			{
				show_404();
			}

			$this->Admin->deleteTable("codes",array("id" => $id));
			@unlink("./codes/".$code->username."/".$code->id.".zip");
			delTree("./codes/".$code->username."/".$code->id."/");
			@rmdir("./codes/".$code->username."/");
			redirect(base_url()."admin/codes",'refresh');
		}
		
		$this->DATA['menu'] 	= 'codes';		
		$this->show("codes");
		
	}	



	public function pages()
	{	
		$this->DATA['title'] 	= 'Pages';	
		if(intval($this->input->get("delete")))
		{
			$this->Admin->deleteTable("pages",array("idpage"=> intval($this->input->get("delete"))));
			redirect(base_url()."admin/pages/");
			exit;
		}
		
		if($this->input->post("page_contact_form"))
		{
			$this->save_settings();
			redirect(base_url()."admin/pages/");
			exit;
		}
		if($this->input->post("text"))
		{
			// Update
			if($this->input->post("idpage"))
			{
				$update = $this->input->post();
				$update['slug'] = url_title($update['title'],"-",TRUE);
				unset($update['_wysihtml5_mode']);
				unset($update['files']);
				$id = intval($update['idpage']);
				unset($update['idpage']);
				$this->Admin->updateTable("pages",$update,array("idpage" => $id));
				
			}
			else
			{
				$save = $this->input->post();
				$save['slug'] = url_title($save['title'],"-",TRUE);
				unset($save['idpage']);
				unset($save['_wysihtml5_mode']);
				unset($save['files']);
				$this->Admin->setTable("pages",$save);
				redirect(base_url()."admin/pages");
			}
		}
		$this->DATA['page'] 	= $this->Admin->getTable("pages",array("idpage" =>  intval($this->input->get("idpage"))))->row_array();	
		$this->DATA['pages'] 	= $this->Admin->getTable("pages",false,"updated DESC")->result_array();
		$this->DATA['menu'] 	= 'pages';	
		$this->show("pages");
	}

	


	public function settings($module = 'website')
	{		
		$this->DATA['title'] 	= 'Settings - '. $module;	
		if(!is_sadmin())
			show_404();
		if($module == 'apperance')
		{
			$this->apperance();
			return false;
		}
		if($module == 'emailservice' && is_demo())
		{
			$this->DATA['menu'] 	= 'settings';		
			$this->DATA['submenu'] 	= $module;		
			$this->show("demo");
			return false;
		
		}
		if(!$module)
			$module = 'website';
		if($this->input->post())
		{
			$this->save_settings();
			redirect(base_url()."admin/settings/".$module);
		}

		$this->DATA['menu'] 	= 'settings';		
		$this->DATA['submenu'] 	= $module;		
		$this->DATA['fields']	 = $this->Admin->getTable("settings",array("module" => $module),"order");		
		$this->show("settings");
	}

	protected function apperance()
	{
		if($this->input->post("save"))
		{
			
			createFolder("uploads");
			createFolder("uploads/stations");
			$upload = uploadImage('./uploads/',sha1($this->input->post('name')),'image');				
			if($upload['image'])
			{	
				$this->Admin->updateTable("settings",array("value" => "uploads/".$upload['image']),array("var" => 'logo'));
			}
			
			$this->save_settings();
		
			redirect(base_url()."admin/settings/apperance");
		}


	
		 $langs  = $this->db->query("
		      SELECT {PRE}languages.* FROM 
		      {PRE}languages,
		      {PRE}translation
		      WHERE
		      {PRE}languages.code = {PRE}translation.code_lang
		      GROUP BY {PRE}languages.name
		      ORDER BY {PRE}languages.name
		      "); 

		$this->DATA['langs'] 	= $langs->result();	
		$this->DATA['menu'] 	= 'settings';	
		$this->DATA['submenu'] 	= 'apperance';	
		$this->show("apperance");

		

	}
	protected function save_settings()
	{
		if($this->input->post())
		{
		
			foreach ($this->input->post() as $key => $value) {
				if(is_array($value))
				{
					//print_p($value);					
					$value = implode(",",$value);
				}
				$this->Admin->setTableIgnore("settings",array("value" => $value,"var" => $key));
				$this->Admin->updateTable("settings",array("value" => $value),array("var" => $key));
				$this->config->set_item($key, $value);  
			}
		}
	}
	
	protected function table_users()
	{
		
	/*
	* Ordering
	*/	$sOrder = false;
		if ($this->input->get('iSortCol_0') || 1==1)
		{
			$columns[0] = 'id';
			$columns[1] = 'avatar';			
			$columns[2] = 'email';						
			$columns[3] = 'names';						
			$columns[4] = 'registered';														
			$columns[5] = 'is_admin';														
			$sOrder = $columns[$this->input->get('iSortCol_0')]." ".$this->input->get('sSortDir_0');			
		}
		$like= false;
		if ($this->input->get('sSearch') != "" )
		{
			foreach ($columns as $key => $value) {
				$like[$value]	= $this->input->get('sSearch');
			}
			
		}
		$users 				= $this->Admin->getTable("users",false,$sOrder,'id,avatar,username,email,names,registered,is_admin,is_demo',$this->input->get('iDisplayLength'),$this->input->get('iDisplayStart'),$like);	
		
		$total 					= $this->Admin->getTable("users",false,$sOrder,'id,avatar,username,email,names,registered,is_admin,is_demo',false,false,$like);	
		$total 					= $total->num_rows();
		$output = array(
		"sEcho" => intval($this->input->get('sEcho')),
		"iTotalRecords" => $total,
		"iTotalDisplayRecords" => $total,
		"aaData" => array()
		);
		foreach ($users->result_array() as $key => $value) {
			$row = array();		
			
			$row[] = $value['id'];
			$row[] = "<img src='".avatar($value['avatar'])."' style='height:30px'>";						
			$row[] = $value['email'];			
			$row[] = $value['names'];			
			$row[] = "<span title='".$value['registered']."'>".ago(($value['registered']))."</span>";			
			if($value['is_admin'] == '1')
			{
				if($value['is_demo'] == '1')
					$row[] = '<small class="label label-danger">ADMIN</small> <small class="label label-success">DEMO</small>';			
				else
					$row[] = '<small class="label label-danger">ADMIN</small>';			
			}
			else
				$row[] = '<small class="label label-info">NORMAL</small>';
					
			$row[] = '<a href="?edit='.$value['id'].'" class="btn btn-warning btn-xs" title="Edit user"><i class="zmdi zmdi-edit"></i> Edit</a>';
			
			$output['aaData'][] = $row;
		}
		
		echo json_encode( $output );
	}



	protected function table_codes()
	{
		
	/*
	* Ordering
	*/	$sOrder = false;
		if ($this->input->get('iSortCol_0') || 1==1)
		{
			$columns[] = 'id';
			$columns[] = 'rating';
			$columns[] = 'username';
			$columns[] = 'title';			
			$columns[] = 'details';			
			$columns[] = 'downloads';						
			$columns[] = 'views';						
			$columns[] = 'size';						
			$columns[] = 'updated';						
			$columns[] = 'updated';						
															
			$sOrder = $columns[$this->input->get('iSortCol_0')]." ".$this->input->get('sSortDir_0');			
		}
		$like= false;
		if ($this->input->get('sSearch') != "" )
		{
			foreach ($columns as $key => $value) {
				$like[$value]	= $this->input->get('sSearch');
			}
			
		}
		
		$codes 				= $this->Admin->getTable("codes",false,$sOrder,implode(",", $columns),$this->input->get('iDisplayLength'),$this->input->get('iDisplayStart'),$like);	
		
		$total 					= $this->Admin->getTable("codes",false,false,"count(id) as total",false,false,$like)->row();	
		$total 					= $total->total;
		$output = array(
		"sEcho" => intval($this->input->get('sEcho')),
		"iTotalRecords" => $total,
		"iTotalDisplayRecords" => $total,
		"aaData" => array()
		);
		foreach ($codes->result_array() as $key => $value) {
			$row = array();		
			$row  = array_values($value);
			
			$row[count($row)] = "<a class='btn btn-danger btn-small btn-xs' href='?remove=".$row[0]."'> <i class='fa fa-times'></i> Remove</a> ";
			
			$row[0] = '<a target="_blank" href="'.base_url().urlencode($row[2])."/".toSlug($row[2])."-".$row[0].'">'.$row[0].'</a>';
			$output['aaData'][] = $row ;
		}
		
		echo json_encode( $output );
	}

	

	public function update()
	{		
		$DATA 				= array();
		
		if($this->input->post("uploading"))
		{			
			if(!file_exists('./uploads/'))
			{
				mkdir('./uploads/');
			}
			$config['upload_path'] 		= './uploads/';
			$config['allowed_types'] 	= 'zip';
			$config['overwrite'] 		=  true;
			$config['remove_spaces']	=  true;
			$this->load->library('upload', $config);
			if ( ! $this->upload->do_upload('upload'))
			{
				$DATA['upload'] = array('error' => $this->upload->display_errors());				
			}
			else
			{
				$DATA['upload'] = array('upload_data' => $this->upload->data());
				$this->load->library('unzip');
				$file = './uploads/'.$DATA['upload']['upload_data']['file_name'];
				if(file_exists($file))
				{					
					$this->unzip->extract($file, './');	
					$errorZip = strip_tags($this->unzip->error_string());
					if($errorZip != '')
						$DATA['upload'] = $errorZip;
					@unlink($file);
					$this->validate_update();
				}
				else
				{
					$DATA['upload'] = array('error' =>'File '.$file." not exist");	
				}
				
				
			}
		}
			
		
		$this->DATA['menu'] 	= 'update';	
		$this->DATA['upload']  = $DATA['upload'];
		if(is_demo())
			$this->show("demo");
		else
			$this->show("update");
	}


}