CREATE TABLE IF NOT EXISTS {PRE}bookmarks (
  idcode varchar(15) NOT NULL,
  iduser int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
ALTER TABLE {PRE}bookmarks ADD UNIQUE KEY idsite (idcode,iduser);
ALTER TABLE `{PRE}bookmarks` ADD `created` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP AFTER `idsite`;
CREATE TABLE IF NOT EXISTS `{PRE}pages` (
`idpage` int(11) NOT NULL,
  `title` varchar(250) NOT NULL,
  `slug` varchar(250) NOT NULL,
  `text` text NOT NULL,
  `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
ALTER TABLE `{PRE}pages` ADD PRIMARY KEY (`idpage`);
ALTER TABLE `{PRE}pages` MODIFY `idpage` int(11) NOT NULL AUTO_INCREMENT;
CREATE TABLE IF NOT EXISTS `{PRE}codes` (
  `id` varchar(15) NOT NULL,
  `title` varchar(150) NOT NULL,
  `details` text NOT NULL,
  `image_large` varchar(200) NOT NULL,
  `image_small` varchar(200) NOT NULL,
  `username` varchar(50) NOT NULL,
  `index` longtext NOT NULL,
  `style` longtext NOT NULL,
  `js` longtext NOT NULL,
  `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `downloads` int(11) NOT NULL,
  `views` int(11) NOT NULL,
  `size` int(11) NOT NULL,
  `rating` decimal(10,2) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
ALTER TABLE `{PRE}codes` ADD UNIQUE KEY `id` (`id`), ADD UNIQUE KEY `title` (`title`(50),`details`(50),`username`(15));
CREATE TABLE IF NOT EXISTS `{PRE}codes_users` (
  `username` varchar(50) NOT NULL,
  `names` varchar(150) NOT NULL,
  `avatar` varchar(250) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
ALTER TABLE `{PRE}codes_users` ADD UNIQUE KEY `username` (`username`);
CREATE TABLE IF NOT EXISTS `{PRE}code_rating` (
  `idcode` varchar(15) NOT NULL,
  `iduser` int(11) NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `rate` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
ALTER TABLE `{PRE}code_rating` ADD UNIQUE KEY `idcode` (`idcode`,`iduser`);
INSERT IGNORE INTO `{PRE}admin_menus` (`idmenu`, `title`, `idunique`, `target`, `icon`, `idparent`) VALUES (NULL, 'Codes', 'codes', 'admin/codes', 'fa fa-code', '');